Skip to content

Assign Users & Groups to Roles on Multiple Documents

Assign users and groups to roles on a document or binder in bulk.

  • The maximum CSV input file size is 1GB.
  • The values in the input must be UTF-8 encoded.
  • CSVs must follow the standard RFC 4180 format, with some exceptions.
  • The maximum batch size is 1000.
POST/api/{version}/objects/documents/roles/batch

Assigning users and groups to document roles is additive. For example, if groups 1, 2, and 3 are currently assigned to a particular role and you assign groups 3, 4, and 5 to the same role, the final list of groups assigned to the role will be 1, 2, 3, 4, and 5. Users and groups (IDs) in the input that are either invalid (not recognized) or cannot be assigned to a role due to permissions are ignored and not processed.

NameDescription
Content-Typetext/csv or application/x-www-form-urlencoded
Acceptapplication/json (default) or application/xml

You can add parameters in the request body, or upload them as a CSV file.

NameDescription
idThe document ID.
role__v.usersA string of user id values for the new role.
role__v.groupsA string of user id values for the new group.

For example,

idreviewer__v.usersreviewer__v.groupsapprover__v.usersapprover__v.groups
771"12021,12022""3311303,3311404"221244411606
curl -X POST -H "Authorization: {SESSION_ID}" \ -H "Content-Type: text/csv" \ -H "Accept: text/csv" \ --data-binary @"C:\Vault\Document Roles\assign_document_roles.csv" \ https://myvault.veevavault.com/api/v19.2/objects/documents/roles/batch
{ "responseStatus": "SUCCESS", "data": [ { "responseStatus": "SUCCESS", "id": 771, "reviewer__v.groups": [ 3311303, 4411606 ], "reviewer__v.users": [ 12021, 12022, 12023, 12124 ] }, { "responseStatus": "SUCCESS", "id": 772, "reviewer__v.groups": [ 3311303, 4411606 ], "reviewer__v.users": [ 12021, 12022, 12023, 12124 ] }, { "responseStatus":"FAILURE", "id":"773", "errors":[ { "type":"INVALID_DATA", "message":"Error message describing why the users and groups were not assigned to roles on this document.." } ] } ] }

The response includes role:id pairs for the users and groups successfully assigned to roles.